# Tuning

## Tuning Pinot

This section provides information on various options to tune Pinot cluster for storage and query efficiency. Unlike Key-Value store, tuning Pinot sometimes can be tricky because the cost of query can vary depending on the workload and data characteristics.

If you want to improve query latency for your use case, you can refer to `Index Techniques` section. If your use case faces the scalability issue after tuning index, you can refer `Optimizing Scatter and Gather` for improving query throughput for Pinot cluster. If you have identified a performance issue on the specific component (broker or server), you can refer to the `Tuning Broker` or `Tuning Server` section.

* [Index Techniques](https://pinot.readthedocs.io/en/latest/index_techniques.html)
* [Star-Tree: A Specialized Index for Fast Aggregations](https://pinot.readthedocs.io/en/latest/star-tree/star-tree.html)
* [Optimizing Scatter and Gather](https://pinot.readthedocs.io/en/latest/tuning_scatter_and_gather.html)
* [Tuning Realtime Performance](https://pinot.readthedocs.io/en/latest/tuning_realtime_performance.html)&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pinot.apache.org/release-0.4.0/operators/operating-pinot/tuning.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
